diff --git a/lib/ethdev/ethdev_driver.h b/lib/ethdev/ethdev_driver.h
index 0174ba03d7..e5c7d08160 100644
--- a/lib/ethdev/ethdev_driver.h
+++ b/lib/ethdev/ethdev_driver.h
@@ -44,18 +44,17 @@ struct rte_eth_rxtx_callback {
 struct rte_eth_dev {
 	eth_rx_burst_t rx_pkt_burst; /**< Pointer to PMD receive function. */
 	eth_tx_burst_t tx_pkt_burst; /**< Pointer to PMD transmit function. */
+	/** Pointer to PMD transmit prepare function. */
 	eth_tx_prep_t tx_pkt_prepare;
-	/**< Pointer to PMD transmit prepare function. */
+	/** Get the number of used RX descriptors. */
 	eth_rx_queue_count_t rx_queue_count;
-	/**< Get the number of used RX descriptors. */
+	/** Check the status of a Rx descriptor. */
 	eth_rx_descriptor_status_t rx_descriptor_status;
-	/**< Check the status of a Rx descriptor. */
+	/** Check the status of a Tx descriptor. */
 	eth_tx_descriptor_status_t tx_descriptor_status;
-	/**< Check the status of a Tx descriptor. */
 
 	/**
-	 * points to device data that is shared between
-	 * primary and secondary processes.
+	 * Device data that is shared between primary and secondary processes.
 	 */
 	struct rte_eth_dev_data *data;
 	void *process_private; /**< Pointer to per-process device data. */
@@ -100,64 +99,63 @@ struct rte_eth_dev_data {
 
 	struct rte_eth_dev_sriov sriov;    /**< SRIOV data */
 
+	/** PMD-specific private data. @see rte_eth_dev_release_port(). */
 	void *dev_private;
-			/**< PMD-specific private data.
-			 *   @see rte_eth_dev_release_port()
-			 */
 
 	struct rte_eth_link dev_link;   /**< Link-level information & status. */
 	struct rte_eth_conf dev_conf;   /**< Configuration applied to device. */
 	uint16_t mtu;                   /**< Maximum Transmission Unit. */
+	/** Common RX buffer size handled by all queues. */
 	uint32_t min_rx_buf_size;
-			/**< Common RX buffer size handled by all queues. */
 
 	uint64_t rx_mbuf_alloc_failed; /**< RX ring mbuf allocation failures. */
+	/** Device Ethernet link address. @see rte_eth_dev_release_port(). */
 	struct rte_ether_addr *mac_addrs;
-			/**< Device Ethernet link address.
-			 *   @see rte_eth_dev_release_port()
-			 */
+	/** Bitmap associating MAC addresses to pools. */
 	uint64_t mac_pool_sel[ETH_NUM_RECEIVE_MAC_ADDR];
-			/**< Bitmap associating MAC addresses to pools. */
+	/**
+	 * Device Ethernet MAC addresses of hash filtering.
+	 * @see rte_eth_dev_release_port()
+	 */
 	struct rte_ether_addr *hash_mac_addrs;
-			/**< Device Ethernet MAC addresses of hash filtering.
-			 *   @see rte_eth_dev_release_port()
-			 */
 	uint16_t port_id;           /**< Device [external] port identifier. */
 
 	__extension__
-	uint8_t promiscuous   : 1,
-		/**< RX promiscuous mode ON(1) / OFF(0). */
+	uint8_t /** RX promiscuous mode ON(1) / OFF(0). */
+		promiscuous   : 1,
+		/** RX of scattered packets is ON(1) / OFF(0) */
 		scattered_rx : 1,
-		/**< RX of scattered packets is ON(1) / OFF(0) */
+		/** RX all multicast mode ON(1) / OFF(0). */
 		all_multicast : 1,
-		/**< RX all multicast mode ON(1) / OFF(0). */
+		/** Device state: STARTED(1) / STOPPED(0). */
 		dev_started : 1,
-		/**< Device state: STARTED(1) / STOPPED(0). */
+		/** RX LRO is ON(1) / OFF(0) */
 		lro         : 1,
-		/**< RX LRO is ON(1) / OFF(0) */
-		dev_configured : 1;
-		/**< Indicates whether the device is configured.
-		 *   CONFIGURED(1) / NOT CONFIGURED(0).
+		/**
+		 * Indicates whether the device is configured.
+		 * CONFIGURED(1) / NOT CONFIGURED(0).
 		 */
+		dev_configured : 1;
+	/** Queues state: HAIRPIN(2) / STARTED(1) / STOPPED(0). */
 	uint8_t rx_queue_state[RTE_MAX_QUEUES_PER_PORT];
-		/**< Queues state: HAIRPIN(2) / STARTED(1) / STOPPED(0). */
+	/** Queues state: HAIRPIN(2) / STARTED(1) / STOPPED(0). */
 	uint8_t tx_queue_state[RTE_MAX_QUEUES_PER_PORT];
-		/**< Queues state: HAIRPIN(2) / STARTED(1) / STOPPED(0). */
 	uint32_t dev_flags;             /**< Capabilities. */
 	int numa_node;                  /**< NUMA node connection. */
+	/** VLAN filter configuration. */
 	struct rte_vlan_filter_conf vlan_filter_conf;
-			/**< VLAN filter configuration. */
 	struct rte_eth_dev_owner owner; /**< The port owner. */
+	/**
+	 * Switch-specific identifier.
+	 * Valid if RTE_ETH_DEV_REPRESENTOR in dev_flags.
+	 */
 	uint16_t representor_id;
-			/**< Switch-specific identifier.
-			 *   Valid if RTE_ETH_DEV_REPRESENTOR in dev_flags.
-			 */
+	/**
+	 * Port ID of the backing device.
+	 * This device will be used to query representor info and calculate
+	 * representor IDs. Valid if RTE_ETH_DEV_REPRESENTOR in dev_flags.
+	 */
 	uint16_t backer_port_id;
-			/**< Port ID of the backing device.
-			 *   This device will be used to query representor
-			 *   info and calculate representor IDs.
-			 *   Valid if RTE_ETH_DEV_REPRESENTOR in dev_flags.
-			 */
 
 	pthread_mutex_t flow_ops_mutex; /**< rte_flow ops mutex. */
 	uint64_t reserved_64s[4]; /**< Reserved for future fields */