diff --git a/lib/ethdev/ethdev_driver.h b/lib/ethdev/ethdev_driver.h
index 7deb9911bd..fdaf20b3c8 100644
--- a/lib/ethdev/ethdev_driver.h
+++ b/lib/ethdev/ethdev_driver.h
@@ -33,7 +33,7 @@ struct rte_eth_rxtx_callback {
 
 /**
  * @internal
- * The generic data structure associated with each ethernet device.
+ * The generic data structure associated with each Ethernet device.
  *
  * Pointers to burst-oriented packet receive and transmit functions are
  * located at the beginning of the structure, along with the pointer to
@@ -85,7 +85,7 @@ struct rte_eth_dev_owner;
 
 /**
  * @internal
- * The data part, with no function pointers, associated with each ethernet
+ * The data part, with no function pointers, associated with each Ethernet
  * device. This structure is safe to place in shared memory to be common
  * among different processes in a multi-process configuration.
  */
@@ -1197,7 +1197,7 @@ struct rte_eth_dev *rte_eth_dev_allocated(const char *name);
 
 /**
  * @internal
- * Allocates a new ethdev slot for an ethernet device and returns the pointer
+ * Allocates a new ethdev slot for an Ethernet device and returns the pointer
  * to that slot for the driver to use.
  *
  * @param	name	Unique identifier name for each Ethernet device
diff --git a/lib/ethdev/ethdev_pci.h b/lib/ethdev/ethdev_pci.h
index 8edca82ce8..12015b6b87 100644
--- a/lib/ethdev/ethdev_pci.h
+++ b/lib/ethdev/ethdev_pci.h
@@ -59,7 +59,7 @@ eth_dev_pci_specific_init(struct rte_eth_dev *eth_dev, void *bus_device) {
 
 /**
  * @internal
- * Allocates a new ethdev slot for an ethernet device and returns the pointer
+ * Allocates a new ethdev slot for an Ethernet device and returns the pointer
  * to that slot for the driver to use.
  *
  * @param dev
diff --git a/lib/ethdev/ethdev_profile.c b/lib/ethdev/ethdev_profile.c
index 0ac9e7cac4..7978f351ac 100644
--- a/lib/ethdev/ethdev_profile.c
+++ b/lib/ethdev/ethdev_profile.c
@@ -24,7 +24,7 @@ profile_hook_rx_burst_cb(
 
 /**
  * Setting profiling Rx callback for a given Ethernet device.
- * This function must be invoked when ethernet device is being configured.
+ * This function must be invoked when Ethernet device is being configured.
  *
  * @param port_id
  *  The port identifier of the Ethernet device.
diff --git a/lib/ethdev/ethdev_vdev.h b/lib/ethdev/ethdev_vdev.h
index 46c75d9e5f..2b49e9665b 100644
--- a/lib/ethdev/ethdev_vdev.h
+++ b/lib/ethdev/ethdev_vdev.h
@@ -13,7 +13,7 @@
 
 /**
  * @internal
- * Allocates a new ethdev slot for an ethernet device and returns the pointer
+ * Allocates a new ethdev slot for an Ethernet device and returns the pointer
  * to that slot for the driver to use.
  *
  * @param dev
diff --git a/lib/ethdev/rte_ethdev.h b/lib/ethdev/rte_ethdev.h
index 0fbb436cd1..6ae6d9ba99 100644
--- a/lib/ethdev/rte_ethdev.h
+++ b/lib/ethdev/rte_ethdev.h
@@ -117,7 +117,7 @@
  * *rte_eth_dev* structure to avoid an extra indirect memory access during
  * their invocation.
  *
- * RTE ethernet device drivers do not use interrupts for transmitting or
+ * RTE Ethernet device drivers do not use interrupts for transmitting or
  * receiving. Instead, Ethernet drivers export Poll-Mode receive and transmit
  * functions to applications.
  * Both receive and transmit functions are packet-burst oriented to minimize
@@ -1316,7 +1316,7 @@ struct rte_eth_conf {
 	struct rte_eth_txmode txmode; /**< Port Tx configuration. */
 	uint32_t lpbk_mode; /**< Loopback operation mode. By default the value
 			         is 0, meaning the loopback mode is disabled.
-				 Read the datasheet of given ethernet controller
+				 Read the datasheet of given Ethernet controller
 				 for details. The possible values of this field
 				 are defined in implementation of each driver. */
 	struct {
@@ -3380,7 +3380,7 @@ rte_eth_tx_buffer_init(struct rte_eth_dev_tx_buffer *buffer, uint16_t size);
  * Configure a callback for buffered packets which cannot be sent
  *
  * Register a specific callback to be called when an attempt is made to send
- * all packets buffered on an ethernet port, but not all packets can
+ * all packets buffered on an Ethernet port, but not all packets can
  * successfully be sent. The callback registered here will be called only
  * from calls to rte_eth_tx_buffer() and rte_eth_tx_buffer_flush() APIs.
  * The default callback configured for each queue by default just frees the
@@ -4746,7 +4746,7 @@ rte_eth_dev_get_name_by_port(uint16_t port_id, char *name);
 
 /**
  * Check that numbers of Rx and Tx descriptors satisfy descriptors limits from
- * the ethernet device information, otherwise adjust them to boundaries.
+ * the Ethernet device information, otherwise adjust them to boundaries.
  *
  * @param port_id
  *   The port identifier of the Ethernet device.
@@ -4816,7 +4816,7 @@ int rte_eth_dev_hairpin_capability_get(uint16_t port_id,
  * @warning
  * @b EXPERIMENTAL: this structure may change without prior notice.
  *
- * ethernet device representor ID range entry
+ * Ethernet device representor ID range entry
  */
 struct rte_eth_representor_range {
 	enum rte_eth_representor_type type; /**< Representor type */